//    WeIRCd IRC server software - sub file
//    Copyright (C) 2007-2009 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

unsigned char hostbuffer[COMPILEOPTION_MAXHOSTLEN+1];
const unsigned char* generate_vhost_guest(const unsigned char* ip) {
	if (cuo.vhost_guest == NULL) {return NULL;}
	unsigned char vhosts[COMPILEOPTION_MAXHOSTLEN+1];
	strncpy(vhosts,cuo.vhost_guest,COMPILEOPTION_MAXHOSTLEN);vhosts[COMPILEOPTION_MAXHOSTLEN] = 0;
	int k = 0;
	strcpy(hostbuffer,"");
	while (strlen(vhosts) > 0 && strlen(hostbuffer) <= COMPILEOPTION_MAXHOSTLEN) {
		if (vhosts[0] != '%') {
			hostbuffer[k] = vhosts[0];
			k++;
			cut(vhosts,1);continue;
		}else{
			if (strstw(vhosts,"%ip") == true) {
				cut(vhosts,strlen("%ip"));
				hostbuffer[k] = 0;
				strncat(hostbuffer,ip,COMPILEOPTION_MAXHOSTLEN);
				hostbuffer[COMPILEOPTION_MAXHOSTLEN] = 0;
				k = strlen(hostbuffer);
				continue;
			}
		}
	}
	return hostbuffer;
}
const unsigned char* generate_vhost_user(const unsigned char* account,const unsigned char* ip) {
	if (cuo.vhost_user == NULL) {return NULL;}
	unsigned char vhosts[COMPILEOPTION_MAXHOSTLEN+1];
	strncpy(vhosts,cuo.vhost_user,COMPILEOPTION_MAXHOSTLEN);vhosts[COMPILEOPTION_MAXHOSTLEN] = 0;
	int k = 0;
	strcpy(hostbuffer,"");
	while (strlen(vhosts) > 0 && strlen(hostbuffer) <= COMPILEOPTION_MAXHOSTLEN-1) {
		if (vhosts[0] != '%') {
			hostbuffer[k] = vhosts[0];
			hostbuffer[k+1] = 0;
			k++;
			cut(vhosts,1);continue;
		}else{
			if (strstw(vhosts,"%ip") == true) {
				cut(vhosts,strlen("%ip"));
				hostbuffer[k] = 0;
				strncat(hostbuffer,ip,COMPILEOPTION_MAXHOSTLEN);
				hostbuffer[COMPILEOPTION_MAXHOSTLEN] = 0;
				k = strlen(hostbuffer);
				continue;
			}
			if (strstw(vhosts,"%account") == true) {
				cut(vhosts,strlen("%account"));
				hostbuffer[k] = 0;
				strncat(hostbuffer,account,COMPILEOPTION_MAXHOSTLEN);
				hostbuffer[COMPILEOPTION_MAXHOSTLEN] = 0;
				k = strlen(hostbuffer);
				continue;
			}
			hostbuffer[k] = vhosts[0];
			hostbuffer[k+1] = 0;
			k++;
			cut(vhosts,1);
		}

	}
	return hostbuffer;
}

