//    WeIRCd IRC server software - sub file
//    Copyright (C) 2007-2009 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//    
#define SENDBUFFERBLOCKSIZE 512
int vsnd2(const unsigned char* oline,int user) {
#ifdef ACTIVATEDEBUG
//	printf("<<[%d] %s\n",user,oline);
#endif
	if (strlen(oline) >= SENDBUFFERBLOCKSIZE) {return -1;}//too big; this is not allowed
	unsigned char line[SENDBUFFERBLOCKSIZE];
	strncpy(line,oline,SENDBUFFERBLOCKSIZE-1);line[SENDBUFFERBLOCKSIZE-1] = 0;
	if (strlen(line) <= 0) {return -1;}
	if (up[user]->hopcount > 0) {
		sendonlink(line,user);
		return;
	}
	if (line[strlen(line)-1] != '\n') {
		if (strlen(line) < SENDBUFFERBLOCKSIZE - 2) {
			strcat(line,"\r\n");
		}else{
			return -1;
		}
	}
	
	int r = 0;
	int k;
	while (r < USER_MAXSENDBUFFERS) {
		if (userpointers[user]->sendbuffer[r] == NULL) {
			break;
		}
		r += 1;
	}
	if (r == 0) {//nothing allocated yet; allocate
		userpointers[user]->sendbuffer[r] = malloc(SENDBUFFERBLOCKSIZE);
		strcpy(userpointers[user]->sendbuffer[r],line);
		userpointers[user]->sendblocks++;
		wantsend++;
		return 0;
	}else{
		if (strlen(userpointers[user]->sendbuffer[r - 1]) + strlen(line) < SENDBUFFERBLOCKSIZE) {
			strcat(userpointers[user]->sendbuffer[r - 1],line);
			return 0;
		}else{
			if (r >= USER_MAXSENDBUFFERS - 1) {
				userQuit(user,USERQUIT_SENDQEXCEEDED);
				return -1;
			}//all pointers used; full!
			if (strlen(userpointers[user]->sendbuffer[r - 1]) >= SENDBUFFERBLOCKSIZE - 1) {
				userpointers[user]->sendbuffer[r] = malloc(SENDBUFFERBLOCKSIZE);
				strcpy(userpointers[user]->sendbuffer[r],line);
				userpointers[user]->sendblocks++;
				wantsend++;
				return 0;
			}else{
				k = SENDBUFFERBLOCKSIZE - (strlen(userpointers[user]->sendbuffer[r - 1]) + 1);
				strncat(userpointers[user]->sendbuffer[r - 1],line,(SENDBUFFERBLOCKSIZE - 1)-strlen(userpointers[user]->sendbuffer[r-1]));
				userpointers[user]->sendbuffer[r-1][SENDBUFFERBLOCKSIZE - 1] = 0;
				cut(line,k);
				userpointers[user]->sendbuffer[r] = malloc(SENDBUFFERBLOCKSIZE);
				strcpy(userpointers[user]->sendbuffer[r],line);
				userpointers[user]->sendblocks++;
				wantsend++;
				return 0;
			}
		}
	}
}
void scrollSendBuffer(int user) {
	int r = 0;
	if (userpointers[user]->sendbuffer[0] != NULL) {free(userpointers[user]->sendbuffer[0]);}
	while (r < USER_MAXSENDBUFFERS - 1) {
		userpointers[user]->sendbuffer[r] = userpointers[user]->sendbuffer[r + 1];
		r += 1;
	}
	userpointers[user]->sendbuffer[USER_MAXSENDBUFFERS - 1] = NULL;
	userpointers[user]->sendblocks--;
	wantsend--;
}
int usnd(int user,const unsigned char* line,...) {
	unsigned char vres[1000] = "";
	unsigned char tmp[51];
	const unsigned char* p;
	va_list ap;
	va_start(ap,line);
	int r = 0;
	while (r < strlen(line)) {
		if (line[r] == '%' && r < strlen(line) - 1) {
			if (line[r + 1] == 's') {
				p = va_arg(ap, char * );
				if (p != NULL) {
					strncat(vres,p,999);
					vres[999] = 0;
				}
				r += 2;continue;
			}
			if (line[r + 1] == 'c') {
				if (strlen(vres) < 998) {
					vres[strlen(vres)+1] = 0;
					vres[strlen(vres)] = (unsigned char)va_arg(ap, int);
				}else{
					int useless = va_arg(ap, int);
				}
				r += 2;continue;
			}
			if (line[r + 1] == 'd') {
				snprintf(&tmp[0],50,"%d",va_arg(ap, int));
				tmp[50] = 0;
				strncat(vres,tmp,999);
				vres[999] = 0;
				r += 2;continue;
			}
			if (line[r + 1] == 'l' && r < strlen(line) - 2) {
				if (line[r + 2] == 'd') {
					snprintf(&tmp[0],50,"%ld",va_arg(ap, long));
					tmp[50] = 0;
					strncat(vres,tmp,999);
					vres[999] = 0;
					r += 3;continue;
				}
				if (line[r + 2] == 'l' && r < strlen(line) - 3) {
					if (line[r + 3] == 'd') {
						snprintf(&tmp[0],50,"%lld",va_arg(ap, long long));
						tmp[50] = 0;
						strncat(vres,tmp,999);
						vres[999] = 0;
						r += 4;continue;
					}
				}
			}
			if (line[r + 1] == 'f') {
				snprintf(&tmp[0],50,"%f",va_arg(ap, double));
				tmp[50] = 0;
				strncat(vres,tmp,999);
				vres[999] = 0;
				r += 2;continue;
			}
			if (line[r + 1] == '%') {
				strncat(vres,"%",999);
				vres[999] = 0;
				r += 2;continue;
			}
		}
		if (strlen(vres) < 998) {
			vres[strlen(vres)+1] = 0;vres[strlen(vres)] = line[r];
		}
		r += 1;
	}
	va_end(ap);
	strncat(vres,"\r\n",999);vres[999] = 0;
	vres[530] = 0;//everything longer makes no real sense
	vsnd2(vres,user);
}
void vsnd(const unsigned char* oline,int user) {vsnd2(oline,user);}
